import peasy.*; //PeasyCamライブラリをインストールしてインポート
PeasyCam cam;

PImage loadPng;
PShape sh;

void setup() {
  size(1024, 768, P3D);
  cam = new PeasyCam(this, 700);
  //標高タイル画像を読み込む
  loadPng = loadImage("10-906-404.png");


  float pixMargin = 5.0;

  sh = createShape();

  //点群で表現する
  /*
  sh.beginShape(POINTS);
  sh.strokeWeight(2);
  sh.stroke(0, 192, 255, 192);
  for (int j=0; j<loadPng.height; j++) {
    for (int i=0; i<loadPng.width; i++) {      
      color pxColor = loadPng.get(i, j);
      float red = red(pxColor);
      float green = green(pxColor);
      float blue = blue(pxColor);

      float x = (i - loadPng.width /2) * pixMargin;
      float y = (j - loadPng.height /2) * pixMargin;
      float z = (red * 256 * 256 + green * 256 + blue) *0.0005;

      sh.vertex(x, y, z);
    }
  }
  sh.endShape();
  */

  //メッシュで表現する
  sh.beginShape(QUADS);
  sh.strokeWeight(1);
  sh.stroke(0, 192, 255, 64);
  sh.noFill();
  color pxColor;
  float red, green, blue, x, y, z;
  float zScale = 0.0005;
  for (int j=0; j<loadPng.height-1; j++) {
    for (int i=0; i<loadPng.width-1; i++) {

      pxColor = loadPng.get(i, j);
      red = red(pxColor);
      green = green(pxColor);
      blue = blue(pxColor);
      x = (i - loadPng.width /2) * pixMargin;
      y = (j - loadPng.height /2) * pixMargin;
      z = (red * 256 * 256 + green * 256 + blue) *zScale;
      sh.vertex(x, y, z);

      pxColor = loadPng.get(i+1, j);
      red = red(pxColor);
      green = green(pxColor);
      blue = blue(pxColor);
      x = (i+1 - loadPng.width /2) * pixMargin;
      y = (j - loadPng.height /2) * pixMargin;
      z = (red * 256 * 256 + green * 256 + blue) *zScale;
      sh.vertex(x, y, z);

      pxColor = loadPng.get(i+1, j+1);
      red = red(pxColor);
      green = green(pxColor);
      blue = blue(pxColor);
      x = (i+1 - loadPng.width /2) * pixMargin;
      y = (j+1 - loadPng.height /2) * pixMargin;
      z = (red * 256 * 256 + green * 256 + blue) *zScale;
      sh.vertex(x, y, z);

      pxColor = loadPng.get(i, j+1);
      red = red(pxColor);
      green = green(pxColor);
      blue = blue(pxColor);
      x = (i - loadPng.width /2) * pixMargin;
      y = (j+1 - loadPng.height /2) * pixMargin;
      z = (red * 256 * 256 + green * 256 + blue) *zScale;
      sh.vertex(x, y, z);
    }
  }
  sh.endShape();
  
}

void draw() {
  background(0);
  shape(sh);
}
