import peasy.*; //PeasyCamライブラリをインストールしてインポート
PeasyCam cam;

PImage loadPng;
PShape sh;
FloatList vertexZ;

void setup() {
  size(1024, 768, P3D);
  cam = new PeasyCam(this, 700);
  //標高タイル画像を読み込む
  loadPng = loadImage("10-906-404.png");
  
  vertexZ = new FloatList();
  float pixMargin = 5.0;

  sh = createShape();

  //点群で表現する
  sh.beginShape(POINTS);
  sh.strokeWeight(2);
  sh.stroke(0, 192, 255, 192);
  for (int j=0; j<loadPng.height; j++) {
    for (int i=0; i<loadPng.width; i++) {      
      color pxColor = loadPng.get(i, j);
      float red = red(pxColor);
      float green = green(pxColor);
      float blue = blue(pxColor);

      float x = (i - loadPng.width /2) * pixMargin;
      float y = (j - loadPng.height /2) * pixMargin;
      float z = (red * 256 * 256 + green * 256 + blue) *0.0005;
      vertexZ.append(z);

      sh.vertex(x, y, z);
    }
  }
  sh.endShape();
}

void draw() {
  background(0);
  for (int j=0; j<loadPng.height; j++) {
    for (int i=0; i<loadPng.width; i++) {    
      PVector v = sh.getVertex(i + j*loadPng.height);
      //地形の高さに加えるノイズを計算
      float noiseHeight = noise(frameCount*0.05, i*0.05, j*0.05) * 80;
      v.z = vertexZ.get(i + j*loadPng.height) + noiseHeight;
      sh.setVertex(i + j*loadPng.height, v);
    }
  }

  shape(sh);
}
