import peasy.*; //PeasyCamライブラリをインストールしてインポート
PeasyCam cam;

PImage loadPng;
PShape sh;

void setup() {
  size(1920, 1080, P3D);
  cam = new PeasyCam(this, 700);
  perspective(PI/3, float(width)/float(height), 1, 1000000);
  cam.setMinimumDistance(-600);
  cam.setMaximumDistance(10000);
  //標高タイル画像を読み込む
  loadPng = loadImage("mtfuji_10-904402-904404.png");


  float pixMargin = 5.0;

  sh = createShape();

  //メッシュで表現する
  sh.beginShape(QUADS);
  sh.noStroke();
  color pxColor;
  float red, green, blue, x, y, z;
  float zScale = 0.0005;
  for (int j=0; j<loadPng.height-1; j++) {
    for (int i=0; i<loadPng.width-1; i++) {

      pxColor = loadPng.get(i, j);
      red = red(pxColor);
      green = green(pxColor);
      blue = blue(pxColor);
      x = (i - loadPng.width /2) * pixMargin;
      y = (j - loadPng.height /2) * pixMargin;
      z = (red * 256 * 256 + green * 256 + blue) *zScale;
      sh.vertex(x, y, z);

      pxColor = loadPng.get(i+1, j);
      red = red(pxColor);
      green = green(pxColor);
      blue = blue(pxColor);
      x = (i+1 - loadPng.width /2) * pixMargin;
      y = (j - loadPng.height /2) * pixMargin;
      z = (red * 256 * 256 + green * 256 + blue) *zScale;
      sh.vertex(x, y, z);

      pxColor = loadPng.get(i+1, j+1);
      red = red(pxColor);
      green = green(pxColor);
      blue = blue(pxColor);
      x = (i+1 - loadPng.width /2) * pixMargin;
      y = (j+1 - loadPng.height /2) * pixMargin;
      z = (red * 256 * 256 + green * 256 + blue) *zScale;
      sh.vertex(x, y, z);

      pxColor = loadPng.get(i, j+1);
      red = red(pxColor);
      green = green(pxColor);
      blue = blue(pxColor);
      x = (i - loadPng.width /2) * pixMargin;
      y = (j+1 - loadPng.height /2) * pixMargin;
      z = (red * 256 * 256 + green * 256 + blue) *zScale;
      sh.vertex(x, y, z);
    }
  }
  sh.endShape();
  
}

void draw() {
  background(0);
  drawLight();
  shape(sh);
}

void drawLight() {
  directionalLight(255, 255, 255, 1, 1, -1);
  ambientLight(64,64,64);
}
